<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="content-type"><title>Tdct Schematic Editor</title>

<meta content="Rolf Keitel" name="author"></head>
<body>
<h2><a name="Schematic_Editor">Schematic
Editor</a></h2>
<br>
<a href="#Introduction">1 Introduction</a><br>
<a href="#Placing_Elements">2 Placing Elements</a><br>
&nbsp;&nbsp;&nbsp; <a href="#Placing_Symbols">2.1
Placing
Symbols</a><br>
&nbsp;&nbsp;&nbsp; <a href="#Placing_Wires">2.2
Placing New Wires</a><br>
&nbsp;&nbsp;&nbsp; <a href="#Placing_Comments">2.3
Placing Comment Text</a><br>
&nbsp;&nbsp;&nbsp; <a href="#Placing_Frames">2.4
Placing Frames</a><br>
<a href="#Selecting_Elements">3 Selecting Elements</a><br>
<a href="#Moving_Symbols">4 Moving Elements</a><br>
<a href="#Configuring_Elements">5 Configuring Elements</a><br>
&nbsp;&nbsp;&nbsp; <a href="#Editing_Symbol_Properties">5.1
Editing Symbol Properties</a><br>
&nbsp; &nbsp; &nbsp; &nbsp; <a href="#symbol_properties_good_practice">5.1.1 Good Practice</a><br>
&nbsp; &nbsp; &nbsp; &nbsp; <a href="#symbol_properties_default">5.1.2 Default Values of
EPICS Record Properties</a><span style="font-weight: bold;"><br>
</span>&nbsp; &nbsp; &nbsp; &nbsp; <a href="#symbol_properties_aliases">5.1.3&nbsp;EPICS
Record Aliases and Information Items</a><br>
&nbsp; &nbsp; &nbsp; &nbsp; <a href="#Assignable_Symbol_Ports">5.1.4 Assignable
Symbol Ports</a><br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; <a href="#Link_field_properties">5.1.5 Link Field Properties</a><br>
&nbsp;&nbsp;&nbsp; <a href="#Moving_Wire_Points">5.2
Editing Wires - Moving Wire Points</a><br>
&nbsp;&nbsp;&nbsp; <a href="#Editing_Comment_Text">5.3
Editing Comment Text</a><br>
&nbsp;&nbsp;&nbsp; <a href="#5.4_Editing_Frames">5.4
Editing Frames</a><br>
<a href="#Finding_Symbols_in_a_Schematic">6 Finding
Symbols in a
Schematic</a><br>
<a href="#Changing_an_EPICS_Record_Type">7 Changing an
EPICS Record Type</a><br>
<a href="#Instance_Ports">8 Instance Ports (dbd mode only)</a><br>
<a href="#Instance_Properties">9 Instance
Properties</a><br>
&nbsp; &nbsp; <a href="#Adding__Removing_Instance">9.1
Adding/Removing Instance Properties</a><br>&nbsp; &nbsp; <a href="#AddingRemoving_Links">9.2 Adding/Removing Links to Other Records</a><br>
&nbsp; &nbsp; <a href="#AddingRemoving_Record_Aliases">9.3
Adding/Removing Record Aliases</a><br>
&nbsp; &nbsp; <a href="#AddingRemoving_Record_Information">9.4
Adding/Removing Record Information Items</a><br>&nbsp; &nbsp; &nbsp; &nbsp; <a href="#Adding_Record_Info_to_Symbol">9.4.1 Adding Record Information Item to a Symbol</a><br>
<a href="#PP_and_MS_Properties">10 PP and MS Properties on
Input and Output Links</a><br>
<br>
<h2>1. <a name="Introduction"></a>Introduction
to Schematic Editing</h2>
The Schematic Editor is an integral part of the tdct application. It
allows placing and configuring of the following elements:<br>
<ul>
<li>symbols</li>
<ul>
<li>EPICS record symbols</li>
<li>user-defined symbols</li>
<li>hierarchical connector symbols</li>
<li>frames</li>
</ul>
<li>wires</li>
<ul>
<li>"normal" wires</li>
<li>wire buses</li>
<li>bus wires</li>
</ul>
<li>text comments</li>
</ul>
<span style="font-style: italic;"><br>
</span>
New schematics are created by selecting from the main menu: &nbsp;<span style="font-style: italic;">File &gt;&gt;
New&nbsp;schematic.</span><br>
Existing&nbsp;schematics are opened from the main menu: <span style="font-style: italic;">File &gt;&gt; Open
Schematic.<br>
</span>Recently modified schematics are opened from the main
menu: <span style="font-style: italic;">File
&gt;&gt; Open Recent.<br>
<br>
</span>The Schematics Editor and the Symbol Editor can work on
different tabs in the same
session. <br>
<br>
<br>
<br>
<br>
<br>
<h2>2. <a name="Placing_Elements">Placing Elements</a></h2>
<h3>2.1 <a name="Placing_Symbols">Placing Symbols</a></h3>
Symbols are placed on a schematic from the <span style="font-style: italic;">Symbol</span> menu. There
are several
options:<br>
<br>
<table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2">
<tbody>
<tr>
<th>Menu command</th>
<th>keyboard shortcut</th>
<th>tdct action</th>
</tr>
<tr>
<td><span style="font-style: italic;">Symbol
&gt;&gt; Add by name</span></td>
<td>N or n</td>
<td>will prompt for &nbsp;a symbol name</td>
</tr>
<tr>
<td><span style="font-style: italic;">Symbol
&gt;&gt; User Symbol</span></td>
<td>P or p</td>
<td>will start a file open dialog for interactively
selecting a
symbol</td>
</tr>
<tr>
<td><span style="font-style: italic;">Symbol
&gt;&gt;
Hierarchical connectors</span></td>
<td>none</td>
<td>will open a secondary menu for selection of hierarchy
connectors</td>
</tr>
<tr>
<td><span style="font-style: italic;">Symbol
&gt;&gt; Epics
Primitives</span></td>
<td>none</td>
<td>will open a secondary menu (*)</td>
</tr>
</tbody>
</table>
<br>
<span style="font-weight: bold;">Notes:</span><br>
(*) By default, the secondary menu collects all EPICS record symbols
from the directories specified with the [epicslib] directive in the
tdct configuration file. Alternatively the content of the secondary
menu(s) can be configured in the tdct configuration file.<br>
<br>
<span style="font-style: italic;"><br>
</span>
<h3>2.2 <a name="Placing_Wires">Placing New Wires</a></h3>
For placing a normal wire, select from the main menu &nbsp;<span style="font-style: italic;">Symbol
&gt;&gt; New wire </span>or use the short-cut
key&nbsp;<span style="font-weight: bold;"> w</span>.<span style="font-style: italic;"></span><span style="font-weight: bold;"><br>
</span>For placing a bus, select from the main menu &nbsp;<span style="font-style: italic;">Symbol
&gt;&gt; New bus </span>or use the short-cut
key&nbsp;<span style="font-weight: bold;"> b</span>.<span style="font-style: italic;"><br>
</span><span style="font-weight: bold;"></span>For
placing a bus wire,
select from the main menu &nbsp;<span style="font-style: italic;">Symbol
&gt;&gt; New bus wire&nbsp; </span>or use the
short-cut key <span style="font-weight: bold;">u</span>.<br>
<br>
<span style="font-weight: bold;">Note:</span> <br>
- tdct allows only
horizontal and vertical wire-segments, i.e. each wire corner forms a 90<sup>o</sup>
angle.<br>
- tdct enforces that wires connect to symbol ports with a horizontal
connection.<br>
<span style="font-style: italic;"></span><span style="font-weight: bold;"><br>
</span>&nbsp;There are two ways of drawing a wire:<br>
<br>
a) <span style="font-weight: bold;">Click-and-Move</span><br>
<span style="font-weight: bold;"></span><span style="font-weight: bold;"><br>
</span><span style="font-style: italic;">Left-click</span>
where you
want the first wire segment to start and <span style="font-style: italic;">move</span> the mouse to
the point where
you want the first
wire segment to end. <span style="font-style: italic;">Left-click</span>
to start the next wire segment, etc.<br>
Finish the last wire segment by<span style="font-weight: bold;">
<span style="font-style: italic;">right</span></span><span style="font-style: italic;">-clicking</span>
at the point where you want the last wire segment to end.<br>
<br>
<span style="font-weight: bold;">b) Press-and-Drag<br>
</span><span style="font-style: italic;">Left-press</span>
where you
want the first wire segement to start and <span style="font-style: italic;">drag</span> the mouse to
the point where
you want the first
wire segment to end. <span style="font-style: italic;">Release</span>
the left button and <span style="font-style: italic;">left-press</span>
to start the next wire segment, etc.<br>
Finish the last wire segment by<span style="font-weight: bold;">
</span><span style="font-style: italic;">right-clicking</span>
at the point where you want the last wire segment to end.<br>
<br>
<h4>Connecting Wires to Symbol Ports</h4>
When you drag a new wire segment and the mouse position is close to a
symbol port, the mouse cursor changes shape to a pointing hand. If you
place a point at this position, the wire is connected to the symbol
port.<br>
<br>
<h4>Connecting Wires to Wires</h4>
When you drag a new wire segment and the mouse position is close to a
segment of a different wire, the mouse cursor changes shape to a
pointing hand. If you
place a point at this position, the wire will be connected with a
junction to the other wire..
<h4>Auto-Routing</h4>
When you place the first wire point on a symbol port and the second
wire point on another symbol port, tdct auto-routes a wire between the
two ports. Tdct attempts to avoid all areas occupied by symbols. It
also attempts&nbsp;not to create overlapping wire segments. The
auto-routing feature can be
disabled from the <span style="font-style: italic;">Options
&gt;&gt;
Modify Configuration</span> menu.<br>
<h4>Buses and Bus Wires</h4>
Buses and bus wires are supported for compatibility with Capfast<span style="font-weight: bold;">&#8482;. </span>I believe anyone
who wants
to use buses would be familiar with their functionality in Capfast.<br>
As a quick recap:<br>
A
bus contains a "range" of wires. Individual wires (bus-wires) can be
"tapped" in or out of the bus at an arbitrary location of the bus.<br>
The developer gives the bus an id of the form &lt;bus
name&gt;[&lt;range&gt;], i.e BUS1[0-9].<br>
Bus-wires have the form &lt;bus name&gt;[&lt;wire
number&gt;], i.e. BUS2[7].<br>
Each
wire has an index which must fall into the bus rage. All bus-wires with
the same wire-index are considered as one logical wire-network by tdct.<br>
<br>
Buses are a
convenient way of passing a group of PVs from one hierarchy level to
another or between symbols at the same level of hierarchy.<br>
Buses can only connect to hierarchy connectors and symbol ports with a
range greater 1.<br>
Bus-wires can only connect to hierarchy connectors and symbol ports
with a range of 1.<br>
(Note that hierarchy connectors and bus ports have&nbsp; the range
1&nbsp;if there is no range specification -.<br>
If
there is a range mis-match, i.e. if &nbsp;the range changes between
a
bus and a hierarchy connector or between a bus and a symbol port, tdct
will issue a warning and ask for confirmation. When building an EPICS
database, these mis-matches are ignored. <br>
<br>
Bus-tap symbols, which are required for&nbsp;compatiblility with
Capfast<span style="font-weight: bold;">&#8482;</span> are
handled automatically by tdct:<br>
<ul>
<li>When
you connect a bus-wire from a symbol port to a bus, a bus-tap is
inserted automatically with a default orientation. The bus-tap
orientation can be flipped about the bus-wire direction by selecting
the bus-tap and SHIFT-right-clicking.</li>
<li>When you disconnect a bus-wire from the bus, the bus-tap is
deleted automatically.</li>
<li>When you delete a bus-wire, the bus-tap is deleted
automatically.</li>
</ul>
<br>
<br>
The bus implementation in tdct is in some aspects more restricted than
in&nbsp;Capfast<span style="font-weight: bold;">&#8482; </span>&nbsp;(e.g.
bus range definition)<br>
<br>
<span style="font-weight: bold;"></span>Some final
remarks:<br>
<br>
The bus support in tdct was new and not well tested before release
2.15,
because we
don't use buses here at TRIUMF.<br>
Thanks to Al Honey form Keck for helping with the testing and debugging
of the bus features.
<ul>
</ul>
<br>
<h3>2.3 <a name="Placing_Comments">Placing Comment
Text</a></h3>
Compatible with&nbsp;Capfast<span style="font-weight: bold;">&#8482;
</span>tdct supports three types of comments, which are ignored
during database building:<br>
<ul>
<li>String Comments</li>
<li>Note-Boxes</li>
<li>Comment Frames</li>
</ul>
<h4>2.3.1 String Comments</h4>
String Comments consist of one line of text. Rotation information in a
schematic is ignored by tdct.<br>
<br>
To place a String Comment, select from the main menu &nbsp;<span style="font-style: italic;">Symbol
&gt;&gt; Comment text </span>or use the short-cut key <span style="font-weight: bold;">T</span>.<span style="font-style: italic;"><br>
</span><br>
A text dialog will prompt you for the comment text and the text size.
Text size is specified as a percentage of the default font size.<br>
When you accept, the text will be placed as a selected item in the top
left corner of the canvas. Drag it to the desired location.<br>
<br>
<h4>2.3.2 Note-Boxes</h4>
Note-Boxes consist of text displayed in a rectangular box.<br>
<br>
To place a Note-Box, select from the main menu &nbsp;<span style="font-style: italic;">Symbol
&gt;&gt;Note-box </span>or use the short-cut key <span style="font-weight: bold;">X</span>. <br>
<br>
<span style="font-style: italic;"></span>Draw a
rectangle to define the width and top of the Note-box.
After releasing the mouse a text dialog will prompt you for the comment
text and the text size.<br>
Text size is specified as a percentage of the default font size. You
can select to fit the text to the box or to maintain original
line-breaks.<br>
<br>
When you accept, the text will be placed in a box at the desired
location. If you selected to fit the text to the box, the text may
overflow the drawn rectangle to the bottom.<br>
<br>
You may select the Note-Box
and drag it to a different location.<br>
<br>
Note-Boxes can be resized. Select, right-click and press the "Resize"
button on the dialog. Then drag a new rectangle.<br>
<br>
<h4>2.3.2 Comment Frames</h4>
Comment Frames consist of a rectangular box with an optional
label.&nbsp;<br>
<br>
To place a Comment Frame, select from the main menu &nbsp;<span style="font-style: italic;">Symbol
&gt;&gt;Comment Frame </span>or use the short-cut key <span style="font-weight: bold;">F</span>.&nbsp;<span style="font-style: italic;"><br>
</span>Draw a rectangle to define the Comment Frame.
After releasing the mouse a text dialog will prompt you for the label
text, label&nbsp; text size and label alignment.<br>
Text size is specified as a percentage of the default font size.<br>
&nbsp;<br>
Note that Comment Frames are selected (like any other frame) via the
main menu <span style="font-style: italic;">Frame
&gt;&gt; Select</span><span style="font-style: italic;">.</span>
If there is more than one Frame or Comment Frame in the schematics
select by left-clicking inside the frame.<br>
You may&nbsp;drag a selected Comment frame to a different location.<br>
<br>
Comment Frames can be resized. Select, right-click and press the
"Resize" button on the dialog. Then drag a new rectangle.<br>
<br>
<br>
<h3>2.4 <a name="Placing_Frames">Placing
Frames</a></h3>
Select from the main menu <span style="font-style: italic;">Frame
&gt;&gt; Add.<br>
</span><br>
Note that Frames are selected&nbsp;&nbsp;via the main menu <span style="font-style: italic;">Frame &gt;&gt; Select.</span>
If there is more than one Frame or Comment Frame in the schematics
select by left-clicking inside the frame.<br>
You may&nbsp;drag a selected&nbsp; Frame to a different
location.<br>
<br>
<br>
<br>
<br>
<br>
<br>
<h2>3 <a name="Selecting_Elements">
Selecting Elements</a></h2>
Any element is selected by left-clicking within its bounding box. Once
selected, the element's colour changes to the "select colour" (default
red). If you are not sure where the bounding box is, use the menu <span style="font-style: italic;">Help &gt;&gt; Show
bounding box</span>.<br>
<br>
You can add&nbsp;to the selection by CTRL-left-clicking on
additional elements.<br>
<br>
Alternatively, you can select one or more elements by drawing a
"Selection Rectangle". There are two ways of doing this:<br>
<ol>
<li>Hold
down the CTRL key, left-press to define one corner of the rectangle,
then left-drag the mouse and left-release to define the opposite corner
of the rectangle.</li>
<li>left-middle-press and drag.</li>
</ol>
<br>
<span style="font-weight: bold;">Exception: </span>&nbsp;Frames
and Comment Frames are
selected from the main menu &nbsp;<span style="font-style: italic;">Frame
&gt;&gt; Select. </span>If there is more than one frame
on a schematic select the desired one after choosing the menu option.<br>
<span style="font-weight: bold;"><br>
<br>
<br>
<br>
<br>
<br>
<br>
</span>
<h2>4 <a name="Moving_Symbols">Moving
Elements</a></h2>
Select an element. Then left-drag to the new position. <br>
<br>
<span style="font-weight: bold;">Note:</span> When
you are moving a
wire, connections at the end points are <span style="font-style: italic; font-weight: bold;">not</span>
maintained.<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<h2>5 <a name="Configuring_Elements">
Configuring Elements</a></h2>
<br>
<h3>5.1 <a name="Editing_Symbol_Properties">
Editing Symbol Instance Properties</a></h3>
After selecting a symbol instance on a schematic, right-click to
display the property dialog. <br>
For
each property you can modify the property value, how the property is
displayed and where the property is located on the schematic.<br>
<br>
To
modify a property value, use the "Edit" column. Depending on the
property type, you can edit the property value with a text entry field
or a combo-box. If you are editing via a text entry field and hit the
ESC key, the original property value will be restored in the text field.<br>
<br>
To
modify how a property is displayed, use the&nbsp;combo box in the
"Display" column. It lets you select "Nothing", "Value Only", or "All".<br>
<br>
To
modify where the property is located on the schematic, use the "Move"
column. After clicking the "Move" button for a
property,&nbsp;left-press on the schematic (which "catches" the
property text) and drag to the desired location on the schematic canvas.<br>
<br>
If
the selected symbol instance represents an EPICS record, the property
dialog will show buttons for adding / removing record aliases or record
information nodes.<br>
&nbsp;<br>
<h4>5.1.1 <a name="symbol_properties_good_practice">Good
Practice</a></h4>
<br>
On a
schematic, it is good
practice to display all EPICS record properties which
have been changed from their default values. In order to make this more
convenient, tdct has the option to display an "Arrange Properties"
dialog after the "Ok" or "Apply" button on the property dialog is
pressed. (This dialog is only displayed if any property values were
changed). This dialog allows moving the changed properties and
controlling if they are displayed or not. For moving a property,
left-click the "Move" button, then left-press on the schematic (which
"catches" the property text) and drag to the desired location.<br>
<br>
This tdct option is by
default enabled, but can be disabled in the configuration file (option:
display_changed_properties). It can also be
enabled/disabled&nbsp;interactively for the current tdct
session&nbsp;with <span style="font-style: italic;">Options
&gt;&gt; Modify Configuration</span>. <br>
<br>
<h4>5.1.2 <a name="symbol_properties_default">Default
Values of EPICS Record Properties</a></h4>
<br>
<br>
In Capfast Compatibility mode:<br>
<ul>
<li>only
properties defined in the EPICS record symbol file are displayed for
modification. The default values are taken from the symbol file.
Additional properties may be added, if they are defined in the edb.def
file.</li>
</ul>
In Dbd mode:<br>
<ul>
<li>an EPICS record property is displayed for modification if
the record's dbd file defines a promptgroup for the property.<br>
The default value of the property is taken from the record symbol file,
. If there is no default value specified in in the record symbol file,
the default is taken from the record's dbd file ("initial" field
property). <br>
If there is no default value specified in the record's dbd file, the
default value is set to</li>
<ul>
<li>0 &nbsp;--&nbsp; for numeric fields</li>
<li>"Soft Channel" for DTYP field</li>
<li>default selection -- for menu fields</li>
<li>"" --for all other fields.</li>
</ul>
<li>In the property dialog, the field names are colour-coded
depending on the origin of the default field value:</li>
<ul>
<li>black &nbsp;-- if the property default value
originates from the dbd file (also if symbol default is equal to dbd
default)</li>
<li>green -- if the property default value originates from
the symbol file.</li>
<li>blue -- if the property value has been modified from the
default.</li>
</ul>
</ul>
<h4>5.1.3 <a name="symbol_properties_aliases">EPICS
Record Aliases and Information Items</a></h4>
In
addition to properties which define record fields, EPICS records may
also contain properties which define aliases for the record name and
information items (see EPICS Application Developers Guide about record
information items and record name aloases). Both features are supported
by tdct and are controlled by the configuration options record_aliases
and record_info.<br>
<br>
If an option is enabled, corresponding buttons will appear on the
record property dialog.<br>
<br>
If
an option is disabled, but a schematic contains properties for this
option, tdct allows the modification of these properties and saves them
with the schematic. The record properties are, however, not written to
the EPICS database.<br>
<br>
<h4>5.1.4 <a name="Assignable_Symbol_Ports">
Assignable Symbol Ports</a></h4>
Some EPICS record symbols have assignable ports,
especially the large symbols. These ports have names such as FLD0,
FLD1, ...<br>
In
the property dialog, they show up as &nbsp; "username(U0)",
"username(U1)", .... &nbsp;and the names FLDx can be set to any
record
field which "makes sense".<br>
In order to "make sense" <br>
<ol>
<li>the record field must be able to accept the data provided
to the port via a wire</li>
<li>the record field must be listed in edb.def for the record
type (in Capfast compatibility mode).</li>
</ol>
<h4>5.1.5 <a name="Link_field_properties">Editing
Link Field Properties</a></h4>
For
details about editing link field properties see the section
about Link
Fields in the Capfast<span style="font-weight: bold;">&#8482;</span>
Compatiblity section.
<h3><a name="Moving_Wire_Points"></a>5.2
Editing Wires - Moving Wire
Points</h3>
After selecting a wire, right-click to enter "wire-edit" mode. The
corners of each wire segment will display a grab-square (default
colour: green). If you move the mouse over a grab-square, the cursor
will change to a pointing hand. Now you can drag the wire point to a
new location. The cursor will change back to an arrow and the
grap-square will show the select colour (default: red). <br>
<br>
If you are dragging a wire end-point over a location where the wire
could make a connection, i.e. a symbol port or another wire, the mouse
cursor will change to a pointing hand.<br>
<br>
<span style="font-weight: bold; font-style: italic;">Note:
</span><span style="font-style: italic;">tdct does
not allow multiple wires to
connect to the same symbol port nor does it allow a wire end point to
connect to a different wire's end point.<br>
<br>
<br>
</span>
<h3><a name="Editing_Comment_Text"></a>5.3
Editing Comment Text</h3>
After selecting a String Comment, a Note-Box or a Comment
Frame,&nbsp; right-click to display the property
dialog.<br>
<br>
<br>
<h3><a name="5.4_Editing_Frames"></a>5.4
Editing Frames</h3>
After selecting a comment text, right-click to display the property
dialog.<br>
<br>
<br>
<br>
<h3><a name="Finding_Symbols_in_a_Schematic"></a>6
Finding Symbols in a
Schematic</h3>
Type CTRL-F and a select box will pop up, which lets you select the
name of one of the symbols used in the schematic (Note: this is the
symbol name, not the symbol instance name). Tdct will select the first
symbol with this name. Use CTRL-F again to advance to the next symbol
with this name. Use ESC to forget the symbol name.<br>
<br>
<h3><a name="Changing_an_EPICS_Record_Type">7
Changing an
EPICS Record Type</a></h3>
This function allows the modification the record type of an EPICS
record instance in the schematic. It assumes you have a single EPICS
record selected.<br>
<br>
Select &nbsp;<span style="font-style: italic;">Edit
&gt;&gt; Change record type</span> from the main menu and
choose the desired record type from the pop-up.<br>
<br>
tdct&nbsp;retains the record name and all record instance
properties of
the original record which&nbsp; are available on the new record
type.
Wire connections are retained if the new record symbol contains a port
at the same location at which the wire was connected to the
original record symbol. A warning is issued if the record
&nbsp;type
change results in unconnected wires.<br>
<br>
<br>
<h3><a name="Instance_Ports"></a>8 Instance
Ports (dbd mode only)</h3>
In dbd mode, "instance ports" can be added to an EPICS record. This
allows wire connections to be attached to record properties, which are
not part of the EPICS library symbol. <br>
The following functions are available from the main menu:<br>
<span style="font-style: italic;">Edit &gt;&gt;
Reuse port</span><br style="font-style: italic;">
<span style="font-style: italic;">Edit &gt;&gt;
Add instance port</span><br style="font-style: italic;">
<span style="font-style: italic;">Edit &gt;&gt;
Reuse instance port</span><br style="font-style: italic;">
<span style="font-style: italic;">Edit &gt;&gt;
Move instance port<br>
<br>
</span>When an instance port is added radiobuttons are used to
select
if the new port is input or output and if the port is added atop or
abottom of the existing ports.<br>
<br>
Once a port is placed it can be moved with the left/right arrow keys.
Vertical port distances are fixed.<br>
<br>
<h3><a name="Instance_Properties"></a>9
Instance
Properties</h3>
<h3><a name="Adding__Removing_Instance"></a>9.1
Adding
/ Removing Instance Properties</h3>
After
a symbol is instantiated on a schematic, selecting and
right-clicking the symbol pops up the the property sheet. It shows all
properties which may be edited by the user.<br>
For user symbols and for EPICS records in Capfast<span style="font-weight: bold;">&#8482; </span>compatibility
mode, the list of &nbsp;properties is defined by the symbol
designer. <br>
Tdct
allows the addition of instance properties to a symbol, which allows
fixing of symbol design shortcomings when modifying a symbol is not
desired.<br>
<br>
Example: the standard EPICS record symbol distribution obtained with
Capfast<span style="font-weight: bold;">&#8482; </span>has
no pproc(OUT) and no palrm(OUT) properties defined in the eaos.sym
file.
In order to make a wire-link form an ao record's OUT field to another
record with the PP property, an instance property pproc(OUT) with value
PP can be added to the record.<br>
<br>
For EPICS records in dbd mode the
editable properties are determined by the dbd files. The addition of
instance properties does not make sense.<br>
<br>
<h3><a name="AddingRemoving_Links"></a>9.2
Adding/Removing Links to Other Records</h3>
Links to other EPICS record are created <br>
<ul>
<li>by setting&nbsp; the &lt;linkfield&gt; property
value &nbsp;on the property sheet to the name of the target PV.<br>
In Capfast<span style="font-weight: bold;">&#8482; </span>compatibility
mode the &lt;linkfield&gt; property &nbsp;has the form
def(&lt;linkfield&gt;), e.g. &nbsp;def(INP)<br>
</li>
<li>by connecting a wire to the link port of the record
instance on a schematic.</li>
</ul>
<br>
<h3><a name="AddingRemoving_Record_Aliases"></a>9.3
Adding/Removing
Record Aliases</h3>
Alias names for EPICS records can be added / removed with buttons on
the record property dialog.<br>
The configuration option <span style="font-family: monospace;">record_aliases</span>
must be set to <span style="font-family: monospace;">true</span>.<br>
<br>
<h3><a name="AddingRemoving_Record_Information"></a>9.4
Adding/Removing
Record Information Items</h3>
Names and values for EPICS record information items can be added /
removed with buttons on the record property dialog.<br>
The configuration option <span style="font-family: monospace;">record_info</span>
must be set to <span style="font-family: monospace;">true</span>.<br>
<h4><a name="Adding_Record_Info_to_Symbol"></a>9.4.1 Adding Record Information Item to a Symbol</h4>
A record information item property may be added to an EPICS record
symbol. In this case, tdct will add the information item to each
database record which is build from an instance of the symbol.<br>The
syntax for adding an information item property to a record symbol is
slightly different than for other record propertes. It requires the prefix "info-" before the info node name.<br><span style="font-family: monospace;">p 408 428 100 0 1 info-syminfo:myvalue</span><br><br>
<h3>10 <a name="PP_and_MS_Properties"></a>PP
and MS Properties on Input and Output Links</h3>
EPICS
record input and output links may specify "process passive" and
"maximize severity" behaviour for the link (in the following called
"ppms properties").<br>
<br>
This behaviour is specified in the link field in the following format:<br>
<span style="font-family: monospace;">&nbsp;&lt;link
field value&gt; = &nbsp;&lt;pv name&gt; [&lt;pp
property&gt;] [&lt;ms property&gt;]</span><br>
where the square brackets denote optional items as usual.<br>
<br>
If
only a PV &lt;pv&gt; is specified, the default behaviour is
equivalent to
&lt;pv&gt; NPP NMS. If the configuration option addnppnms is
set to
true, the PV name in the&nbsp;link field in the EPICS database will
have " NPP NMS" appended. If the option is set to false, only the PV
name will appear in the link field.<br>
<br>
The &lt;pv name&gt; must be followed by at least one space
before the other properties are entered.<br>
<br>
Valid values for &lt;pv property&gt; are: NPP, PP, CA, CP,
and&nbsp; CPP.<br>
<br>
Valid values for &lt;ms property&gt; are: NMS and MS.<br>
<br>
Since
release 2.12.5, non-default ppms properties are displayed on the
wire-segment next to the link port.<br>
<br>
<br>
<span style="font-weight: bold;"><a name="ppms_capfast"></a>Capfast&#8482;
compatibility mode<br>
<br>
</span>In&nbsp;Capfast<span style="font-weight: bold;">&#8482;
</span>compatibility mode there exist the properties
pproc(&lt;link field&gt;) and palrm(&lt;link field&gt;)
for specifying <span style="font-family: monospace;">&lt;pp
property&gt; </span>and<span style="font-family: monospace;"> </span><span style="font-family: monospace;">&lt;ms property&gt; </span>for
the &lt;link field&gt;. The pproc and palrm properties work
together with the configuration option pproc_wireonly:<br>
<br>
If
pproc_wireonly is true, tdct uses the pproc and palrm properties only
for links which are specified with a wire, not for links which are
specified by a link field value..<br>
<br>
If
pproc_wires_only is false, tdct uses pproc and palrm properties also
for links which are specified by a link field value. If the link
field values specifies a <span style="font-family: monospace;">&lt;pp
property&gt;</span> , the pproc property is ignored. If the
link field values specifies an <span style="font-family: monospace;">&lt;ms
property&gt;</span> , the palrm property is ignored.<br>
<br>
Since
release 2.12.5, the ppms properties can also be specified by
double-clicking on a wire segment next to a link port. The values
selected will modify the EPICS record's pproc and palrm properties.<br>
<br>
<br>
<span style="font-weight: bold;"><a name="ppms_dbd"></a>Dbd
mode<br>
<br>
</span>Since release 2.12.5, the ppms properties must be
specified by double-clicking on a wire segment next to a link port. <span style="font-weight: bold;"><br>
</span><br>
<br>
<span style="font-weight: bold;"><a name="ppms_hwio"></a>Hardware
I/O<br>
<br>
</span>If
a link field value is specified on a hwin or hwout symbol (which is
connected by wire to the link field), ppms properties on the hardware
I/O symbol override the ppms properties defined on the wire or the
record's link field<span style="font-weight: bold;"><br>
</span><br>
<br>
<span style="font-style: italic;"></span>
</body></html>